#include<bits/stdc++.h>

using namespace std;

int main()
{
    int t;
    cin>>t;
    int c[t] = {1};
    for(int i=0; i<t; i++)
    {
        c[i] = 1;
        int n, m;
        cin>>n>>m;
        long long a[n];
        long long b[m];
        for(int j=0; j<n; j++) cin>>a[j];
        for(int j=0; j<m; j++) cin>>b[j];
        sort(a, a + n);
        sort(b, b + m);
        long long x=1000000000000000000, y;
        for(int j=1; j<n; j++)
        {
            y = a[j] - a[j-1];
            if(x>y) x=y;
        }
        for(int j=1; j<n; j++)
        {
            if(((a[j]-a[j-1]) - x) % x != 0) {c[i] = 0; break;}
        }
        for(int j=0; j<m; j++)
        {
            if((max(b[j], a[0]) - min(b[j], a[0])) % x==0) {c[i] = 0; break;}
        }
    }
    for(int i=0; i<t; i++) cout <<c[i]<< endl;
    return 0;
}